// NanoRogue 2.0
// Copyright (C) 2021 by Mark Damon Hughes
// https://mdhughes.tech/
// Permission is granted to copy this disk
// in its entirety.
// Turbo Basic XL by Frank Ostrowski, 1985
// ----
// https://vintageisthenewold.com/2021-basic-10-liner-contest-is-on/
// PUR-120 tier
// ----
// Item		ASCII	Code	Gr.1			Effect
// Floor	.	$2E 46	$AE 174 (blue)		Open
// Wall		#	$23 35	$23 35 (orange)		Block
// Stairs	>	$3E 62	$3E 62 (orange)		Reload Level
// Rat		R	$52 82	$F2 242 (pink)		1 HP
// Zombie	Z	$5A 90	$FA 250 (pink)		9 HP
// Dragon	D	$44 68	$E4 228 (pink)		21 HP
// Gold		$	$24 36	$04 (yellow)		d20 GP
// Player	@	$40 64	$60 96 (yellow)		You
// ----

5	POKE731,1		// noclick
	GR.1			// 20x20 wide chars, 40x4 regular
	SE.1,13,15		// palette 1 to gold
	W=20			// world size
	DIME$(30),M(W,W)	// E$() encounter table, M() map
	//RRRZZZD$$..........#######>ZDD
	E$="\xF2\xF2\xF2\xFA\xFA\xFA\xE4\x04\x04\xAE\xAE\xAE\xAE\xAE\xAE\xAE\xAE\xAE\xAE#######\x3E\xFA\x04\x04"
	H=10		// Hit Points
	L=1		// Level
	// G=0		// Gold, default value
	?"NANOROGUE BY MDHUGHES"

6	I."DIFFICULTY (1-4)?",F:IF F<1 OR F>4 THEN 6

10	P=W/2:Q=W/2		// Player pos
	P0=P:Q0=Q		// Last pos
	F.Y=0TOW-1		// Generate/draw map
		F.X=0TOW-1
			N=RAND(27)+F
			M(X,Y)=ASC(E$(N,N))
			M(P,Q)=$AE	// Force player start to be empty
			?#6;CHR$(M(X,Y));
		N.X
	N.Y

20	C.M(P0,Q0):PL.P0,Q0	// redraw old
	C.$60:PL.P,Q		// redraw player pos
	P0=P:Q0=Q		// remember where we were

	CLS
	?"H:";H,"L:";L,"G:";G,"DIFF:";F		// draw status line
	IF H<=0THEN?"YOU DIED\xFD"
		GET K
		END

30	POKE752,1		// cursor inhibit
	GET K
	H=H-(K=$51)*999			// Q = death
	P=(P-(K=$41)+(K=$44)+W)MOD W 	// W/S = up/down
	Q=(Q-(K=$57)+(K=$53)+W)MOD W	// A/D = left/right

40	M=M(P,Q)
	D=(M=$F2)*1+(M=$FA)*9+(M=$E4)*21	// Damage taken from monsters
	H=H-D*F
	IF M=$04 THEN M(P,Q)=$AE
		N=RAND(20)+1
		G=G+N
		?N;" GP! ";

	// Announce kill if you survive
41	IF D>0 AND H>0 THEN M(P,Q)=$AE
		G=G+D
		?"KILLED ";CHR$(M);" ";
		// Sharp beep
		F.Z=1TO 60:SO.0,90+Z*2,8,10:N.Z:SO.

	// Level up
42	IF H>0 AND G>=L*10 THEN ?"LEVEL UP! ";
		G=G-L*10
		L=L+1
		H=L*10
		// Rising beep
		F.Z=1TO 60:SO.0,140-Z*2,10,10:N.Z:SO.

50	IF M=$23	// Wall, beep, bounce back a step, game loop
		P=P0:Q=Q0
		F.Z=1TO 20:SO.0,240,10,10:NEXT Z:SO.	// short hard beep
		G.20
	ELSE:IF M=$3E
		G.60
	ELSE
		G.20	// in any case, game loop
	ENDIF:ENDIF	// TBXL has to close each IF/ELSE

	// Stairs down, just recreate the map!
	// Increase difficulty +1 every 5 levels
60	IF L>F*5 AND F<4:F=F+1:ENDIF
	CLS #6
	G.10
